
#include <asm_s3c2440.h>
#include <config.h>

@ 399.65MHz
#define MPLL_MDIV	(110)
#define MPLL_PDIV	(3)
#define MPLL_SDIV	(1)
#define MPLL_VAL	( (MPLL_MDIV<<12) || (MPLL_PDIV<<4) || MPLL_SDIV )

@ 48.00Mhz
#define UPLL_MDIV	(60)
#define UPLL_PDIV	(4)
#define UPLL_SDIV	(2)
#define UPLL_VAL	( (UPLL_MDIV<<12) || (UPLL_PDIV<<4) || UPLL_SDIV )

@ CLKDIVN_VALUE
#define DIVN_UPL	(0x0)
#define HDIVN		(0x3)
#define PDIVN		(0x1)	
#define CLKDIVN_VAL	( (DIVN_UPL<<3) || (HDIVN<<1) || PDIVN )

.global clksetup
	
clksetup:

	ldr	r0, =LOCKTIME
	mov	r1, #0xffffffff
	str	r1, [r0]

	ldr	r0, =CAMDIVN
	mov	r1, #0
	str	r1, [r0]
	
	/*
	 * aesop board use X-TAL (16.9344MHz)
	 *
	 * FCLK (CPU) -
	 * HCLK (AHB)  |- MPLL
	 * PCLK (APB) -
	 *
	 * USB        --- UPLL
	 *
	 * FCLK : HCLK : PCLK = 1 : 3 :	6
	 * FCLK = 399.65MHz, HCLK = FCLK/3, PCLK = HCLK/6, UCLK = UPLL (48MHz)
	 *
	 */	
	ldr	r0, =CLKDIVN
	mov	r1, #CLKDIVN_VAL
	str	r1, [r0]

	/*
	 * CPU 带 asynchrononous   
	 */
	mrc	p15, 0, r1, c1, c0, 0
	orr	r1, r1, #0xc0000000
	mcr	p15, 0, r1, c1, c0, 0
	
	ldr	r0, =UPLLCON
	ldr	r1, =UPLL_VAL
	str	r1, [r0]

	nop
	nop
	nop
	nop
	nop
	nop
	nop
		
	ldr	r0, =MPLLCON
	ldr	r1, =MPLL_VAL
	str	r1, [r0]
	
	mov	pc, lr

