
/*
 * LED 1,2 control module
 */		
	
#include <asm_s3c2440.h>
#incldue <config.h>
			
#define WAIT_TIME	0xff00
	
.text

.global	_led_init
.global _led_on
.global _led_off
.global _led_wait_time		

_led_init:
	ldr	r5, =GPCCON	@ LED 1,2 Output mode
	ldr	r1, [r5]
	and	r1, r1, #(~(0xF<<12))
	orr	r1, r1, #(0x5<<12)
	str	r1, [r5]

	ldr	r5, =GPCUP	@ pull up register disable
	ldr	r1, [r5]
	orr	r1, r1, #(0x3<<6)
	str	r1, [r5]

	mov	pc, lr

	
_led_off:			
	ldr	r5, =GPCDAT	@ LED 1,2 Init (LED off)
	ldr	r1, [r5]
	orr	r1, r1, #(0x3<<6)
	str	r1, [r5]

	mov	pc, lr

	
_led_on:
	ldr	r5, =GPCDAT
	ldr	r1, [r5]				
	bic	r1, r1, r0
	str	r1, [r5]

	mov	pc, lr

	
_led_wait_time:
	mov	r1, #WAIT_TIME
wait:	
	nop
	nop
	
	subs	r1, r1, #1
	bne	wait

	mov	pc, lr
