
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <arm9.h>

//#define BIG_ENDIAN	1
#define LITTLE_ENDIAN	1

/*
 * bootloader DEBUG   ¸ LED ǥش
 */
#define DEBUG
//#define RELEASE

/*
 * FCLK/HCLK/PCLK define
 *  - FCLK:HCLK:PCLK = 1:3:6
 *  - boot/clksetup.S 
 */
#define FCLK	399650000
#define HCLK	(FCLK/3)
#define PCLK	(HCLK/2)


/*
 * NOR FLASH Ǵ  ̹ location
 * - total NOR size : 2M
 * - bootloader size Ŀ Ŀ ڷ ̷
 */
#define KERNEL_IMAGE_START_NOR	0x10000
#define KERNEL_IMAGE_END_NOR	0x100000

/*
 * SDRAM Ǵ  ̹ location
 */
#define KERNEL_IMAGE_START_RAM	0x30200000

/*
 * stack location, size
 *  - stack's push/pop asm command use stmfd and ldmfd
 *  - then don't need (stack_start_addr - 4)
 */
#define STACK_SVC_START		(KERNEL_IMAGE_START_RAM)
#define STACK_SVC_SIZE		0x20000

#define STACK_IRQ_START		(STACK_SVC_START - STACK_SVC_SIZE)
#define STACK_IRQ_SIZE		0x20000

#define STACK_ABORT_START	(STACK_IRQ_START - STACK_IRQ_SIZE)
#define STACK_ABORT_SIZE	0x10000

#define STACK_FIQ_START		(STACK_ABORT_START - STACK_ABORT_SIZE)
#define STACK_FIQ_SIZE		0x5000

#define STACK_UDEF_START	(STACK_FIQ_START - STACK_FIQ_SIZE)
#define STACK_UDEF_SIZE		0x4000

#define TASK_CONTEXT_FRAME	68

/*
 * Exception vector table
 */
#define _ISR_STARTADDRESS	0x30100000

//#if 0
/* #define pISR_RESET		(*(unsigned *)(_ISR_STARTADDRESS+0x0)) */
/* #define pISR_UNDEF		(*(unsigned *)(_ISR_STARTADDRESS+0x4)) */
/* #define pISR_SWI		(*(unsigned *)(_ISR_STARTADDRESS+0x8)) */
/* #define pISR_PABORT		(*(unsigned *)(_ISR_STARTADDRESS+0xc)) */
/* #define pISR_DABORT		(*(unsigned *)(_ISR_STARTADDRESS+0x10)) */
/* #define pISR_RESERVED		(*(unsigned *)(_ISR_STARTADDRESS+0x14)) */
/* #define pISR_IRQ		(*(unsigned *)(_ISR_STARTADDRESS+0x18)) */
/* #define pISR_FIQ		(*(unsigned *)(_ISR_STARTADDRESS+0x1c)) */
//else
#define pISR_RESET		(KERNEL_IMAGE_START_RAM + 0x0 )
#define pISR_UNDEF		(KERNEL_IMAGE_START_RAM + 0x4 )
#define pISR_SWI		(KERNEL_IMAGE_START_RAM + 0x8 )
#define pISR_PABORT		(KERNEL_IMAGE_START_RAM + 0xc )
#define pISR_DABORT		(KERNEL_IMAGE_START_RAM + 0x10)
#define pISR_RESERV		(KERNEL_IMAGE_START_RAM + 0x14)
#define pISR_INTREQ		(KERNEL_IMAGE_START_RAM + 0x18)
#define pISR_FINTREQ		(KERNEL_IMAGE_START_RAM + 0x1c)
//#endif

#endif
