
#include <config.h>
#include <string.h>
#include <blue_kernel.h>
#include <blue_tasks.h>
#include <tcb.h>

extern tcb_t *curr_task;
extern task_list_t *task_ready_list;
extern task_list_t *task_blocking_list;

void hw_init();
void tasks_enroll();

void start_kernel(void)
{

	hw_init();
	uptime_init();
	task_init();

	/* TODO: semapore, mutex init	*/
	/* TODO: system calls		*/
	/* TODO: system timers		*/

	tasks_enroll();

	curr_task = task_list_get_first_node(&task_ready_list);
	curr_task->task_stat = RUNNING;

	timer4_start();
	_run_higher_prior_order_task();

	/*
	 *  ϴ   ̴.   ´ٸ 뷫
	 */
	while(1)
		kernel_panic();
}

void hw_init()
{

	uart_init();

	/* TODO: MMU init	*/

	interrupt_init();

	/* TODO: LCD driver	*/
	/* TODO: KEY button	*/
}

void tasks_enroll()
{

	/* task_create(task_name, task_func, task_stack, task_stack_size, task_prior, task_slice */
	task_create("idle_task", 
		    idle_main, 
		    idle_task_stack, 
		    DEFAULT_TASK_STACK, 
		    IDLE_TASK_PRIOR, 
		    1);

	task_create("blueshell_task",
		    blueshell_main,
		    blueshell_task_stack,
		    DEFAULT_TASK_STACK,
		    BLUESHELL_TASK_PRIOR,
		    10);

	/* TODO: GAME TASKs */
}

