
/*
 * UART device driver
 */

/*
 * TODO: uart get/put  κп semapore ߰Ǿ  
 */

#include <c_s3c2440.h>
#include <config.h>
#include <blue_kernel.h>

void uart_init()
{

	/*
	 * UART0 Ұ.
	 * nCTS0, nRTS0, TXD0, RXD0 ϰڴٰ 
	 */
	rGPHCON &= ~0xff;
	rGPHCON |= 0xaa;
	rGPHUP  |= 0xf;

	/*
	 * ULCON0 = Uart Line Control Register
	 *  - word length: 8bit
	 *  - stop bit   : one bit per frame
	 *  - parity mode: No parity
	 *  - Infrared mode: Normal mode operation
	 */
	rULCON0 = 0x03;

	/*
	 * UCON0 = Uart Control Register
	 * Transmit/Receive Mode set Interrupt request or polling mode
	 * Uart Baud Rate use PCLK
	 */
	rUCON0 = 0x245;

	/*
	 * UFCON = Uart FIFO Control Register
	 * UART0 FIFO 
	 */
	rUFCON0 = 0x07; 
	
	/*
	 * UMCON = Uart Modem Control Register
	 */
	rUMCON0 = 0x0;
    
	/*
	 * UBRDIV0 = Uart Baud Rate Division Register
	 * 
	 * UBRDIV0 = (int)(PCLK/bps * 16)-1 or
	 *           (int)(UCLK/bps * 16)-1
	 */
	rUBRDIV0 = (int)(PCLK/(115200*16))-1;
}

char uart_getc()
{

	while (!(rUTRSTAT0 & 0x01))
		;
    
	return rURXH0 & 0x0ff;
}

/*
 *  gets   ũ⸦ Ѿ װ ִµ
 *   ũ⸦ Ѿ ϸ Է ޴° ϰ
 *   '\0'  ־־
 *  Լ ڵȴ
 */
char *uart_gets(char *buffer, int size)
{

	int i;

	for (i=0; i<size; i++)
	{
		/*
		 * ۺ ū ڿ  ϸ
		 *    0 ؼ Ѵ.
		 */
		if (i == size)
		{
			buffer[i-1] = '\0';
			return buffer;
		}
	
		buffer[i] = uart_getc();
		if (buffer[i] == 13)	/* 13 = CR = '\r', 10 = LF = '\n' */
		{
			buffer[i] = '\0';
			uart_putc('\n');
	    
			return buffer;
		}
		uart_putc(buffer[i]);
	}

	return '\0';
}

void uart_putc(const char c)
{

	/*
	 * transmit buffer register  ٸ
	 */
	while(!(rUTRSTAT0&0x2))
		;
    
	/*
	 * ۽ŵ (8-Ʈ)
	 */
	rUTXH0 = (unsigned char)(c);
    
	if (c == '\n')
	{
		while(!(rUTRSTAT0&0x02))
			;
		rUTXH0 = '\r';
	}
}

void uart_puts(const char *s)
{

	while (*s)
		uart_putc(*s++);
}
