
#include <blue_kernel.h>

unsigned long uptime_ms;
unsigned long uptime_sec;

void uptime_init()
{

	uptime_ms	= 0;
	uptime_sec	= 0;
}

unsigned long uptime_increase_ms()
{

	static boolean LED2_ON = FALSE;

	uptime_ms++;
	if( (uptime_ms % 999) == 0 )
	{
		uptime_sec++;

		if( LED2_ON )
		{
			LED2_ON = FALSE;
			_led_off();
		}
		else
		{
			LED2_ON = TRUE;
			_led_on(LED2);
		}
	}

	return uptime_ms;
}

/*
 * busy waiting delay function
 */
void delay(unsigned int ms)
{
  
	unsigned int wakeup_ms;

	wakeup_ms = ms + uptime_ms;
	while( wakeup_ms >= uptime_ms )
		;
}


